import DefaultParameterMapNodeOptions from './default-parameter-map-node-options.js';
import DefaultParameterMapNodeResult from './default-parameter-map-node-result.js';
/**
 * Returns the default elastix parameter map for a given transform type.
 *
 * @param {string} transformName - Transform name. One of: translation, rigid, affine, bspline, spline, groupwise
 * @param {DefaultParameterMapNodeOptions} options - options object
 *
 * @returns {Promise<DefaultParameterMapNodeResult>} - result object
 */
declare function defaultParameterMapNode(transformName: string, options?: DefaultParameterMapNodeOptions): Promise<DefaultParameterMapNodeResult>;
export default defaultParameterMapNode;
