import DefaultParameterMapOptions from './default-parameter-map-options.js';
import DefaultParameterMapResult from './default-parameter-map-result.js';
/**
 * Returns the default elastix parameter map for a given transform type.
 *
 * @param {string} transformName - Transform name. One of: translation, rigid, affine, bspline, spline, groupwise
 * @param {DefaultParameterMapOptions} options - options object
 *
 * @returns {Promise<DefaultParameterMapResult>} - result object
 */
declare function defaultParameterMap(transformName: string, options?: DefaultParameterMapOptions): Promise<DefaultParameterMapResult>;
export default defaultParameterMap;
