import { JsonCompatible } from 'itk-wasm';
import ElastixNodeOptions from './elastix-node-options.js';
import ElastixNodeResult from './elastix-node-result.js';
/**
 * Rigid and non-rigid registration of images.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation
 * @param {ElastixNodeOptions} options - options object
 *
 * @returns {Promise<ElastixNodeResult>} - result object
 */
declare function elastixNode(parameterObject: JsonCompatible, options?: ElastixNodeOptions): Promise<ElastixNodeResult>;
export default elastixNode;
