import { JsonCompatible } from 'itk-wasm';
import ElastixOptions from './elastix-options.js';
import ElastixResult from './elastix-result.js';
/**
 * Rigid and non-rigid registration of images.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation
 * @param {ElastixOptions} options - options object
 *
 * @returns {Promise<ElastixResult>} - result object
 */
declare function elastix(parameterObject: JsonCompatible, options?: ElastixOptions): Promise<ElastixResult>;
export default elastix;
