// Generated file. To retain edits, remove this comment.
import { InterfaceTypes, runPipeline } from 'itk-wasm';
import { getPipelinesBaseUrl } from './pipelines-base-url.js';
import { getPipelineWorkerUrl } from './pipeline-worker-url.js';
import { getDefaultWebWorker } from './default-web-worker.js';
/**
 * Rigid and non-rigid registration of images.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation
 * @param {ElastixOptions} options - options object
 *
 * @returns {Promise<ElastixResult>} - result object
 */
async function elastix(parameterObject, options = {}) {
    const desiredOutputs = [
        { type: InterfaceTypes.Image },
        { type: InterfaceTypes.TransformList },
        { type: InterfaceTypes.JsonCompatible },
    ];
    const inputs = [
        { type: InterfaceTypes.JsonCompatible, data: parameterObject },
    ];
    const args = [];
    // Inputs
    const parameterObjectName = '0';
    args.push(parameterObjectName);
    // Outputs
    const resultName = '0';
    args.push(resultName);
    const transformName = '1';
    args.push(transformName);
    const transformParameterObjectName = '2';
    args.push(transformParameterObjectName);
    // Options
    args.push('--memory-io');
    if (options.fixed) {
        const inputCountString = inputs.length.toString();
        inputs.push({ type: InterfaceTypes.Image, data: options.fixed });
        args.push('--fixed', inputCountString);
    }
    if (options.moving) {
        const inputCountString = inputs.length.toString();
        inputs.push({ type: InterfaceTypes.Image, data: options.moving });
        args.push('--moving', inputCountString);
    }
    if (options.initialTransform) {
        const inputCountString = inputs.length.toString();
        inputs.push({ type: InterfaceTypes.TransformList, data: options.initialTransform });
        args.push('--initial-transform', inputCountString);
    }
    if (options.initialTransformParameterObject) {
        const inputCountString = inputs.length.toString();
        inputs.push({ type: InterfaceTypes.JsonCompatible, data: options.initialTransformParameterObject });
        args.push('--initial-transform-parameter-object', inputCountString);
    }
    const pipelinePath = 'elastix';
    let workerToUse = options?.webWorker;
    if (workerToUse === undefined) {
        workerToUse = await getDefaultWebWorker();
    }
    const { webWorker: usedWebWorker, returnValue, stderr, outputs } = await runPipeline(pipelinePath, args, desiredOutputs, inputs, { pipelineBaseUrl: getPipelinesBaseUrl(), pipelineWorkerUrl: getPipelineWorkerUrl(), webWorker: workerToUse, noCopy: options?.noCopy });
    if (returnValue !== 0 && stderr !== "") {
        throw new Error(stderr);
    }
    const result = {
        webWorker: usedWebWorker,
        result: outputs[0]?.data,
        transform: outputs[1]?.data,
        transformParameterObject: outputs[2]?.data,
    };
    return result;
}
export default elastix;
//# sourceMappingURL=elastix.js.map