// Generated file. To retain edits, remove this comment.
import { InterfaceTypes, runPipelineNode } from 'itk-wasm';
import path from 'path';
import { fileURLToPath } from 'url';
/**
 * Read elastix parameter text files into a parameter object.
 *
 * @param {ReadParameterFilesNodeOptions} options - options object
 *
 * @returns {Promise<ReadParameterFilesNodeResult>} - result object
 */
async function readParameterFilesNode(options = { parameterFiles: [], }) {
    const mountDirs = new Set();
    const desiredOutputs = [
        { type: InterfaceTypes.JsonCompatible },
    ];
    const inputs = [];
    const args = [];
    // Inputs
    // Outputs
    const parameterObjectName = '0';
    args.push(parameterObjectName);
    // Options
    args.push('--memory-io');
    if (options.parameterFiles) {
        if (options.parameterFiles.length < 1) {
            throw new Error('"parameter-files" option must have a length > 1');
        }
        args.push('--parameter-files');
        options.parameterFiles.forEach((value) => {
            mountDirs.add(path.dirname(value));
            args.push(value);
        });
    }
    const pipelinePath = path.join(path.dirname(fileURLToPath(import.meta.url)), 'pipelines', 'read-parameter-files');
    const { returnValue, stderr, outputs } = await runPipelineNode(pipelinePath, args, desiredOutputs, inputs, mountDirs);
    if (returnValue !== 0 && stderr !== "") {
        throw new Error(stderr);
    }
    const result = {
        parameterObject: outputs[0]?.data,
    };
    return result;
}
export default readParameterFilesNode;
//# sourceMappingURL=read-parameter-files-node.js.map