import { Image, JsonCompatible } from 'itk-wasm';
import TransformixNodeOptions from './transformix-node-options.js';
import TransformixNodeResult from './transformix-node-result.js';
/**
 * Apply an elastix transform parameter object to an image.
 *
 * @param {Image} moving - Moving image
 * @param {JsonCompatible} transformParameterObject - Elastix transform parameter object to apply. Only provide this or an initial transform.
 * @param {TransformixNodeOptions} options - options object
 *
 * @returns {Promise<TransformixNodeResult>} - result object
 */
declare function transformixNode(moving: Image, transformParameterObject: JsonCompatible, options?: TransformixNodeOptions): Promise<TransformixNodeResult>;
export default transformixNode;
