import { Image, JsonCompatible } from 'itk-wasm';
import TransformixOptions from './transformix-options.js';
import TransformixResult from './transformix-result.js';
/**
 * Apply an elastix transform parameter object to an image.
 *
 * @param {Image} moving - Moving image
 * @param {JsonCompatible} transformParameterObject - Elastix transform parameter object to apply. Only provide this or an initial transform.
 * @param {TransformixOptions} options - options object
 *
 * @returns {Promise<TransformixResult>} - result object
 */
declare function transformix(moving: Image, transformParameterObject: JsonCompatible, options?: TransformixOptions): Promise<TransformixResult>;
export default transformix;
