import { JsonCompatible } from 'itk-wasm';
import WriteParameterFilesNodeResult from './write-parameter-files-node-result.js';
/**
 * Write an elastix parameter text file from a parameter object.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation.
 * @param {string[]} parameterFiles - Elastix parameter files, must have the same length as the number of parameter maps in the parameter object.
 *
 * @returns {Promise<WriteParameterFilesNodeResult>} - result object
 */
declare function writeParameterFilesNode(parameterObject: JsonCompatible, parameterFiles: string[]): Promise<WriteParameterFilesNodeResult>;
export default writeParameterFilesNode;
