// Generated file. To retain edits, remove this comment.
import { InterfaceTypes, runPipelineNode } from 'itk-wasm';
import path from 'path';
import { fileURLToPath } from 'url';
/**
 * Write an elastix parameter text file from a parameter object.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation.
 * @param {string[]} parameterFiles - Elastix parameter files, must have the same length as the number of parameter maps in the parameter object.
 *
 * @returns {Promise<WriteParameterFilesNodeResult>} - result object
 */
async function writeParameterFilesNode(parameterObject, parameterFiles) {
    const mountDirs = new Set();
    const desiredOutputs = [];
    const inputs = [
        { type: InterfaceTypes.JsonCompatible, data: parameterObject },
    ];
    const args = [];
    // Inputs
    const parameterObjectName = '0';
    args.push(parameterObjectName);
    // Outputs
    parameterFiles.forEach((p) => args.push(p));
    parameterFiles.forEach((p) => mountDirs.add(path.dirname(p)));
    // Options
    args.push('--memory-io');
    const pipelinePath = path.join(path.dirname(fileURLToPath(import.meta.url)), 'pipelines', 'write-parameter-files');
    const { returnValue, stderr, } = await runPipelineNode(pipelinePath, args, desiredOutputs, inputs, mountDirs);
    if (returnValue !== 0 && stderr !== "") {
        throw new Error(stderr);
    }
    const result = {};
    return result;
}
export default writeParameterFilesNode;
//# sourceMappingURL=write-parameter-files-node.js.map