import { JsonCompatible } from 'itk-wasm';
import WriteParameterFilesOptions from './write-parameter-files-options.js';
import WriteParameterFilesResult from './write-parameter-files-result.js';
/**
 * Write an elastix parameter text file from a parameter object.
 *
 * @param {JsonCompatible} parameterObject - Elastix parameter object representation.
 * @param {string[]} parameterFiles - Elastix parameter files, must have the same length as the number of parameter maps in the parameter object.
 * @param {WriteParameterFilesOptions} options - options object
 *
 * @returns {Promise<WriteParameterFilesResult>} - result object
 */
declare function writeParameterFiles(parameterObject: JsonCompatible, parameterFiles: string[], options?: WriteParameterFilesOptions): Promise<WriteParameterFilesResult>;
export default writeParameterFiles;
